#ifndef COPERATION_H
#define COPERATION_H

#include "libboxmanage_global.h"
#include <QString>
#include <QMap>
#include <QWidget>

namespace Box {

enum {
    E_BOX_PROPERTY_NEWBOXNAME = 0,
    E_BOX_PROPERTY_ISUSEDBOXSM,
};

class LIBBOXMANAGE_EXPORT COperation
{
public:
    COperation(QWidget *parent = nullptr) { m_pParent = parent; }
    virtual ~COperation() {}

public:
    inline void set_boxName(QString boxname){ m_pBoxName = boxname; }
    inline QString get_boxName(){ return m_pBoxName; }

    inline void set_boxPath(QString boxpath){ m_pBoxPath = boxpath; }
    inline QString get_boxPath(){ return m_pBoxPath; }

    inline void set_property(int key, const QString &value) { m_propertyMap[key] = value; }
    inline void get_property(int key, QString &value) { value = m_propertyMap[key]; }

    void form_inWidgetCenter(QWidget* widget, QWidget *frm){
        if (NULL == widget || NULL == frm)
            return;

        QRect rect = widget->geometry();

        int frmX = frm->width();
        int frmY = frm->height();

        QPoint movePoint((widget->width() / 2 - frmX / 2) + rect.x(), (widget->height() / 2 - frmY / 2) + rect.y());

        frm->move(movePoint);
    }

protected:
    void set_ukuiWidgetHint(int winId);

public:
    virtual int exec_operation() = 0;

protected:
    QWidget *m_pParent;
    QString m_pBoxName;
    QString m_pBoxPath;
    QMap<int, QString> m_propertyMap;
};
}

#endif // COPERATION_H
